import java.util.*;

/**
 * Lab #3 CS 2334, Section 0?? February 8, 2016
 * <P>
 * This class implements a program that tests the Book class code.
 * </P>
 * 
 * @author Dean Hougen and (your names)
 * @version 1.0
 */
public class Lab3Driver {

	/**
	 * This is the main method for this driver program.
	 * <P>
	 * Algorithm<br>
	 * Test out the Book class and an ArrayList of them to help your
	 * understanding of creating, sorting, and searching lists.
	 * </P>
	 * 
	 * @param args
	 *            Contains the command line arguments.
	 */

	public static void main(String[] args) {
		ArrayList books = new ArrayList();

		/*
		 * Instantiate eight objects of type Book and add them to the list
		 * books. I have created and added the first Book for you. :)
		 */

		/*
		 * This is a list of the genres that we create for one Book. This list
		 * is referenced by the variable "genres. You can add to this list by
		 * invoking the add method in ArrayList.
		 */
		ArrayList genres = new ArrayList();
		genres.add("Autobiography");
		genres.add("Adventure");
		genres.add("History");

		Book firstBook = new Book("There and Back Again", "B.B.", 3018, genres);

		/*
		 * The Book list is referenced by the variable books. You can add to this list
		 * by invoking the add method in ArrayList.
		 */
		books.add(firstBook);

		/*
		 * Create and add the other seven Book objects here.
		 */

		/*
		 * Print out the unsorted list of books. This uses an iterator to
		 * "iterate" through the list.
		 */
		System.out.println("\n\nUnsorted List:");

		Iterator iterator = books.iterator();

		while (iterator.hasNext()) {
			// Note: This line of code will automatically call the toString
			// method of the Book class.
			System.out.println(iterator.next());
		}

		/*
		 * Sort the list of Books using Collections.sort(). Take a look at
		 * Collections.sort() in the API at
		 * http://download.oracle.com/javase/8/docs/api/java/util/Collections.html#sort%28java.util.List%29
		 * 
		 * You need to call Collections.sort() and pass it the list of Books.
		 * SEE THE LAB HANDOUT FOR MORE INFORMATION.
		 */

		// ADD CODE TO SORT HERE

		/*
		 * Print out the sorted list of Books.
		 */
		System.out.println("Sorted List:");
		/*
		 * HINT: Use an iterator the same way I used one above when the unsorted
		 * list of Books was printed.
		 */

		// ADD CODE TO PRINT THE LIST HERE

		/*
		 * Search for a particular Book in the list.
		 */
		System.out.println("\n\nSearching");
		Book key = new Book("Analysis: The Arrakeen Crisis", "Princess Irulan", 10282, "Politics");
		System.out.println("Key is " + key);

		/*
		 * Call Collections.binarySearch() to find the index of key. Make sure
		 * you test the value of index to see if it negative, which indicates
		 * that the key was not found in the list.
		 */

		int index = Collections.binarySearch(books, key);

		/*
		 * Print out whether the Book was found or not and the index at which it
		 * was found. HINT: If index is negative print a statement saying that
		 * the item searched for is not in the list. Otherwise, print out a
		 * statement telling that item was found in the list and give the index
		 * of item in the list as well.
		 */

		// ADD CODE HERE

	}
}